#(c) 2021 Christophe Gueneau
#Pour robot MaqueenPlus

from microbit import *
from time import sleep_ms
from machine import time_pulse_us

def initI2C():
        buf = bytearray(1)
        buf[0] = 0x32
        version=0
        while version==0:
            i2c.write(0x10, buf)
            version=(i2c.read(0x10, 1))[0]
        display.show("v"+ str(version))
        sleep(500)
        display.show(" ")

def moteur(dirG, vitG, dirD, vitD):
    buf = bytearray(5)
    buf[0] = 0x00
    buf[1] = dirG
    buf[2] = vitG
    buf[3] = dirD
    buf[4] = vitD
    i2c.write(0x10, buf)

def moteurG(dir, vit):
    buf = bytearray(3)
    buf[0] = 0x00
    buf[1] = dir
    buf[2] = vit
    i2c.write(0x10, buf)

def moteurD(dir, vit):
    buf = bytearray(3)
    buf[0] = 0x02
    buf[1] = dir
    buf[2] = vit
    i2c.write(0x10, buf)

def moteurStop():
    buf = bytearray(2)
    buf[0] = 0x00
    buf[1] = 0
    i2c.write(0x10, buf)
    buf[0] = 0x02
    buf[1] = 0
    i2c.write(0x10, buf)

def ligne(indexCapteur):
    buf = bytearray(1)
    buf[0] = 0x1D
    i2c.write(0x10, buf)
    etatByte = (i2c.read(0x10, 1)[0])               #on récupère l'octet d'index 0 dans le tableau
    etatCapteur = etatByte & 2**(indexCapteur-1)    #masque
    if etatCapteur != 0:
        etatCapteur = 1
    return etatCapteur

def servo(index, angle):
    buf =bytearray(2)
    if(index == 1):
        buf[0]=0x14
    if(index == 2):
        buf[0]=0x15
    if(index == 3):
        buf[0]=0x16
    buf[1]=angle
    i2c.write(0x10, buf)

def ledRgb(couleurG, couleurD):
    buf = bytearray(3)
    buf[0] = 0x0b
    buf[1] = couleurG
    buf[2] = couleurD
    i2c.write(0x10, buf)

def distance(pinTrig, pinEcho):
    pinTrig.write_digital(1)
    sleep_ms(10)
    pinTrig.write_digital(0)
    pinEcho.read_digital()
    t = time_pulse_us(pinEcho, 1)
    d = 340 * t // 20000
    return d

moteur(0, 0, 0, 0)


